//package ???;

import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.util.List;

import org.apache.log4j.Logger;
import org.jdom.Attribute;
import org.jdom.Document;
import org.jdom.Element;
import org.jdom.input.SAXBuilder;

/**
 * Hilfs-Methoden zur Arbeit mit JDOM
 *
 * @author Heiner Kcker
 */
public class JDomUtil
{
  private static Logger log = Logger.getLogger(JDomUtil.class);

  /**
   * parse the given InputStream.
   *
   * @param pInputStream
   * @return
   */
  public static Document parse(// --
      //final String pFileName, //--
      final InputStream pInputStream)
  {
    Document doc = null;
    try
    {
      // Das Parsen:
      SAXBuilder builder = new SAXBuilder();
      doc = builder.build(// --
          // new File(pFileName)
          pInputStream);

      // Die Ausgabe:
      // XMLOutputter fmt = new XMLOutputter();
      // fmt.output(doc, System.out);
    }
    catch (Exception e)
    {
      // e.printStackTrace();
      log.error("", e);
    }
    finally
    {
      StreamUtils.close( pInputStream );
    }
    return doc;
  }

  /**
   * Konvertiere die bergebenen XML-DOM-Struktur
   * in Java-Collections (Vector, Hashtable).
   *
   * @param pDocument
   * @return
   */
  public static final VectorValueHashtable convertToJavaCollection( // --
      final Document pDocument)
  {
    if ( pDocument == null )
    {
      return null;
    }
    if (pDocument.hasRootElement())
    {
      Element rootElement = pDocument.getRootElement();
      final VectorValueHashtable retHashtable = new VectorValueHashtable();
      convertToJavaCollectionRecursiv( // --
          rootElement, // --
          retHashtable);
      return retHashtable;
    }
    else
    {
      // was soll ich hier machen ?
      // TODO Schleife ber main elemente noch fertig programmieren
      // throw new RuntimeException();
      return null;
    }

  }

  /**
   * Rekursive Hilfsmethode zum Konvertieren der
   * bergebenen XML-DOM-Struktur in
   * Java-Collections (Vector, Hashtable).
   *
   * @param pRootElement
   * @return
   */
  private static final void convertToJavaCollectionRecursiv(// --
      final Element pElement, // --
      final VectorValueHashtable pParentHastable)
  {
    // --- Text des Elementes ---
    final String elementText = pElement.getTextNormalize();
    if ( ! StringUtil.isEmpty(elementText) )
    {
      pParentHastable.put( // --
          pElement.getName(), // --
          elementText);
    }

    final List<Attribute> attrList = pElement.getAttributes();
    final List<Element> childList = pElement.getChildren();

    final VectorValueHashtable subHashtable = // --
    new VectorValueHashtable( // --
        attrList.size() + // --
            childList.size());

    // --- Attribute des Elementes ---
    for (int j = 0; j < attrList.size(); j++)
    {
      Attribute attribute = attrList.get(j);
      final String attrName = attribute.getName();
      final String attrValue = attribute.getValue();
      subHashtable.put(attrName, attrValue);
    }

    // --- Kind-Elemente des Elementes ---
    for (int i = 0; i < childList.size(); i++)
    {
      Element element = childList.get(i);

      convertToJavaCollectionRecursiv( // --
          element, // --
          subHashtable);
    }

    if (subHashtable.size() > 0)
    {
      pParentHastable.put( // --
          pElement.getName(), // --
          subHashtable);
    }
  }

}
