//package ???;

import java.util.Hashtable;
import java.util.Map;
import java.util.Vector;

/**
 * Eine Hashtable mit mehreren mglichen Eintrgen
 * (value) je Schlssel (key).
 *
 * Wenn beim Einfgen eines Wertesauf dem spezifizierten Key
 * ein Wert vorgefunden wird, wird dieser alte Wert mit dem
 * neuen zusammen in einem Vector abgelegt.
 *
 * Falls der alte Wert bereits ein Vector ist, wird dieser
 * Vector um den neuen Wert erweitert.
 *
 * @author Heiner Kcker
 */
public class VectorValueHashtable //--
extends Hashtable
{

  /**
   * serial version id generated by eclipse
   */
  private static final long serialVersionUID = 7187844924654423383L;

  /**
   * Constructor
   * @param pInitialCapacity
   * @param pLoadFactor
   */
  public VectorValueHashtable(int pInitialCapacity, float pLoadFactor)
  {
    super(pInitialCapacity, pLoadFactor);
    // TODO Auto-generated constructor stub
  }

  /**
   * Constructor
   * @param pInitialCapacity
   */
  public VectorValueHashtable(int pInitialCapacity)
  {
    super(pInitialCapacity);
    // TODO Auto-generated constructor stub
  }

  /**
   * Constructor
   */
  public VectorValueHashtable()
  {
    super();
    // TODO Auto-generated constructor stub
  }

  /**
   * Constructor
   * @param pT
   */
  public VectorValueHashtable(Map pT)
  {
    super(pT);
    // TODO Auto-generated constructor stub
  }

  /* (non-Javadoc)
   * @see java.util.Hashtable#put(K, V)
   */
  @Override
  public synchronized Object put(//--
      final Object pKey, //--
      final Object pValue)
  {
    if ( this.get( pKey ) == null )
    {
      // der Schlsselplatz ist noch frei
      return super.put(pKey, pValue);
    }
    final Object oldValue = this.get( pKey );
    if ( oldValue instanceof Vector )
    {
      // es gibt schon einen Vector
      final Vector vector = (Vector) oldValue;
      // neuen Wert anhngen
      vector.add( pValue );
      // und vermerken
      return super.put(pKey, vector);
    }
    else
    {
      // es gibt noch keinen Vector, neuen Vector anlegen
      final Vector vector = new Vector( 4 );
      // alten Wert anhngen
      vector.add( oldValue );
      // neuen Wert anhngen
      vector.add( pValue );
      // und vermerken
      return super.put(pKey, vector);
    }
    //return oldValue;
  }

  /* (non-Javadoc)
   * @see java.util.Hashtable#toString()
   */
  @Override
  public synchronized String toString()
  {
    // TODO Auto-generated method stub
    return super.toString();
  }

}
